		RADIX dec
;
		list	p=16F873           ; list directive to define processor
        #include	<p16F873.inc>
        errorlevel -302			; suppress "register not in bank0, check page bits" message.	
;




; smallest pulse in milliseconds (keep no higher than 500 to fit in 8 bits)
#define pulseLenght 500
; Timer pulse lenght in seconds
#define OnTime	1
clockrate equ 4000000         ;define clock rate here
pulseconst	equ	((pulseLenght*clockrate)/(4000*256*8))
timerconst	equ	((OnTime*1000)/pulseLenght)

vars	UDATA_SHR	
delay	RES 2					; 0.5 s delay
timer	RES 1					; Timer (0.5 s units)



vectors	CODE	0
		goto start

master	CODE	10
start
   
	BCF STATUS, RP0 ;
	BCF STATUS, RP1 ; Bank0
	CLRF PORTA ; Initialize PORTA by
				; clearing output
				; data latches
	BSF STATUS, RP0 ; Select Bank 1
	MOVLW 0x06 ; Configure all pins
	MOVWF ADCON1 ; as digital inputs
	MOVLW 0xCF ; Value used to
				; initialize data
				; direction
	MOVWF TRISA ; Set RA<3:0> as inputs
				; RA<5:4> as outputs
				; TRISA<7:6>are always
				; read as 0.
	BCF STATUS, RP0 ;
	BCF STATUS, RP1 ; Bank0

		clrf timer

main	movlw 0xff
		movwf PORTA
		call HSdelay
		clrf PORTA
		call HSdelay
		goto main

HSdelay	clrf delay
		movlw pulseconst
		movwf delay+1
l1		goto l1a
l1a		goto l1b
l1b		nop
		decfsz delay,f
		goto l1
		decfsz delay+1,f
		goto l1
		return






		end
